const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const sales_allocations = sequelize.define(
    'sales_allocations',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

quantity: {
        type: DataTypes.DECIMAL,
      
      

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  sales_allocations.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity
























































//end loop



    db.sales_allocations.belongsTo(db.sales_order_lines, {
      as: 'sales_order_line',
      foreignKey: {
        name: 'sales_order_lineId',
      },
      constraints: false,
    });

    db.sales_allocations.belongsTo(db.lots, {
      as: 'lot',
      foreignKey: {
        name: 'lotId',
      },
      constraints: false,
    });

    db.sales_allocations.belongsTo(db.serial_numbers, {
      as: 'serial_number',
      foreignKey: {
        name: 'serial_numberId',
      },
      constraints: false,
    });

    db.sales_allocations.belongsTo(db.locations, {
      as: 'location',
      foreignKey: {
        name: 'locationId',
      },
      constraints: false,
    });

    db.sales_allocations.belongsTo(db.organizations, {
      as: 'organizations',
      foreignKey: {
        name: 'organizationsId',
      },
      constraints: false,
    });




    db.sales_allocations.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.sales_allocations.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return sales_allocations;
};


